
// Joyduino by Marq/Fit
// 14.10.2011: New pinout, initial support for two sticks
// 6.10.2011: The initial version

#define JOY1 128
#define JOY2 64

// Bits for joy direction/button bytes
#define JOY_UP    1
#define JOY_DOWN  2
#define JOY_LEFT  4
#define JOY_RIGHT 8
#define JOY_B1    16
#define JOY_B2    32

// Joy direction/button pins in Arduino for joystick 1
#define PIN1_UP    2
#define PIN1_DOWN  3
#define PIN1_LEFT  4
#define PIN1_RIGHT 5
#define PIN1_B1    6
#define PIN1_B2    7 // Not used yet

// Joy direction/button pins in Arduino for joystick 2
#define PIN2_UP    8
#define PIN2_DOWN  9
#define PIN2_LEFT  10
#define PIN2_RIGHT 11
#define PIN2_B1    12
#define PIN2_B2    13 // Pin 1 doesn't work anyway with serial

void setup()
{
  // Init all pins to output and make them inactive
  for(int n=PIN1_UP; n<=PIN2_B2; n++)
  {
    pinMode(n,OUTPUT);
    digitalWrite(n,LOW);
  }
  
  Serial.begin(115200);
  Serial.print("Joyduino at your service!");
}

void loop()
{
  while(Serial.available()>0)
  {
    int c=Serial.read(),
        startpin,startbit=JOY_UP;
    
    if(c&JOY1)
      startpin=PIN1_UP;
    else
      startpin=PIN2_UP;
      
    // Go through joybits and switch pins accordingly
    for(int n=0; n<6; n++,startbit<<=1)
    {
      if(c&startbit)
        digitalWrite(startpin+n,HIGH);
      else
        digitalWrite(startpin+n,LOW);
    }
  }
}
